eval 'exec perl -S $0 ${1+"$@"}'  # -*-Mode:Perl; perl-indent-level:8-*-
    if 0;
#
# Copyright (c) 1998 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#       This product includes software developed by the Computer Systems
#       Engineering Group at Lawrence Berkeley Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# stpdump_parse.pl: Perl script for converting tcpdump plots of STP into xgraph
# 
# This code framework contributed by Giao Nguyen
# 
# Written by Tom Henderson, 9/98
# 


# Generic option-grabbing code
sub Getopt
{
	local($spec) = @_;	# name of variables to be initialized from %opt
	&Usage	if ($#ARGV < 0);
	while ($_ = $ARGV[0], /^-(\w+)/) {
		shift @ARGV;
		$key = $1;
		$opt{$key} = (index($spec, "$key:") >= 0) ? shift @ARGV : 1;
	}

}

sub Usage
{
	$0 =~ s/.*\/([^\/]+)$/$1/o;
	print <<EOF;
Usage:  $0 tcpdumpfile

Process tcpdump output to generate an xgraph plot of an STP connection.
tcpdumpfile is an ascii representation of the tcpdump.
For this to work, you need to run tcpdump as follows to generate an 
appropriate dumpfile:
tcpdump -x -s 128 host HOST1 and host HOST2 > tcpdumpfile

Note:  In the xgraph, POLLs count both SDP and POLL PDUs, and the USTAT marks 
the first missing PDU reported.
EOF
	exit 1;
}

&Getopt("");
# From a previous script; example of how to add options
# &Getopt("e:type:tps:bw:");
# $opt_tps = $opt{'tps'}  if ($opt{'tps'} > 0.01);
# $opt_xgraph = $opt{'xgraph'};
# $opt_bw = ($opt{'bw'} || 1e4) / 0.008;      #	 convert to bytes per second
# $opt_e = $opt{'type'} ? $opt{"type"} . ' (\d+)' : $opt{'e'};

$SIG{'INT'} = 'Finish';

open(SEGS, ">temp.segs") or die "Can't open temp.segs: $!\n";
open(POLLS, ">temp.polls") or die "Can't open temp.polls: $!\n";
open(SDPS, ">temp.sdps") or die "Can't open temp.sdps: $!\n";
open(STATS, ">temp.stats") or die "Can't open temp.stats: $!\n";
open(USTATS, ">temp.ustats") or die "Can't open temp.ustats: $!\n";
open(XGR, ">temp.rands") or die "Can't open temp.rands: $!\n";
while (<>) {
	chop;
	# Get time offset from first SYN
        if (($orig = $_) =~ /: /) {
                # split tcpdump line into:  $ip = (time,src,dst), $_=(data)
                ($ip, $_) = ($`, $');
                ($now, $src, $to, $dst) = split(/ /, $ip);
                $now =~ s/^(\d+):(\d+):(.+)/60 * (60 * $1 + $2) + $3/e;
                $t0 = $now  if (! $t0);
                $now -= $t0;
                @src_array = split /\./, $src;
                @dst_array = split /\./, $dst;
                $source = $src_array[0]  if (! $source);
                $dest = $dst_array[0]  if (! $dest);
		if ($source eq $src_array[0]) {
			$_ = <>;
			$_ = <>;
			@data_array = split;
			if ($data_array[4] =~ /(\w\w)(\w\w)/) {
				$ch1 = $1;
				$ch2 = $2;
			}
			$num1 = hex($ch2);
			$num2 = hex($data_array[5]);	
			$num = (65536 * $num1) + $num2;
			$initial = $num if (! $initial);
			$num -= $initial;
			if ($ch1 eq "01" || $ch1 eq "03") {
                        	print SEGS "$now $num\n";
			}
			if ($ch1 eq "02") {
                        	print POLLS "$now $num\n";
			}
			if ($ch1 eq "03") {
                        	print SDPS "$now $num\n";
			}
		} elsif ($dest eq $src_array[0]){
			$_ = <>;
			$_ = <>;
			@data_array = split;
			if ($data_array[4] =~ /(\w\w)(\w\w)/) {
				$ch1 = $1;
				$ch2 = $2;
			}
			if ($ch1 eq "04") {
				$num1 = hex($ch2);
				$num2 = hex($data_array[5]);	
				$num = (65536 * $num1) + $num2;
				$num -= $initial;
                        	print STATS "$now $num\n";
			}
			if ($ch1 eq "06") {
				$_ = <>;
				@data_array = split;
				if ($data_array[0] =~ /(\w\w)(\w\w)/) {
					$ch1 = $1;
					$ch2 = $2;
					$num1 = hex($ch2);
					$num2 = hex($data_array[1]);	
					$num = (65536 * $num1) + $num2;
					$num -= $initial;
                        		print USTATS "$now $num\n";
				}
			}
		}
        }
}
	close POLLS;
	close SDPS;
	close SEGS;
	close STATS;
	close USTATS;

	# output the throughput (kbps) every $opt_tps seconds
# Prepare the xgraph plot file
	open(SEGS, "<temp.segs") or die "Can't open temp.segs: $!\n";
	open(POLLS, "<temp.polls") or die "Can't open temp.polls: $!\n";
	open(SDPS, "<temp.sdps") or die "Can't open temp.sdps: $!\n";
	open(STATS, "<temp.stats") or die "Can't open temp.stats: $!\n";
	open(USTATS, "<temp.ustats") or die "Can't open temp.ustats: $!\n";
	print XGR "TitleText: stpdump_plot\nDevice: Postscript\n";
	$quote = '"';
	print XGR $quote;
	print XGR "packets\n";
	while(<SEGS>) {
		print XGR $_;
	}

	print XGR "\n$quote";
	print XGR "polls\n";
	while(<POLLS>) {
		print XGR $_;
	}
	while(<SDPS>) {
		print XGR $_;
	}
	print XGR "\n$quote";
	print XGR "ustats\n";
	print XGR "0 0\n";
	while(<USTATS>) {
		print XGR $_;
	}
	print XGR "\n$quote";
	print XGR "stats\n";
	while(<STATS>) {
		print XGR $_;
	}
	close XGR;
	close POLLS;
	close SDPS;
	close SEGS;
	close STATS;
	close USTATS;

	exec "xgraph -bb -tk -nl -m -x time -y packet temp.rands &";
sub Finish
{
	# $| = 1;  select(STDOUT);
	close STDOUT;			# also flush STDOUT
	exit;
}
